/*
    QuickMSG
    Copyright (C) 2014  Jeroen Vreeken <jeroen@vreeken.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _INCLUDE_MAILBOX_H_
#define _INCLUDE_MAILBOX_H_

#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <stdbool.h>

struct mailbox;

struct mailbox * mailbox_create(
    char *server, unsigned short port, char *login, char *pass);
void mailbox_destroy(struct mailbox *);

int mailbox_connect(struct mailbox *);
int mailbox_disconnect(struct mailbox *);

int mailbox_mkdir(struct mailbox *, char *dir);

int mailbox_chdir(struct mailbox *, char *dir);

int mailbox_ls(struct mailbox *, uint32_t **, size_t *nr);


int mailbox_get_id_headers(struct mailbox *mailbox, uint32_t id, char **header, size_t *length);
int mailbox_get_id_body(struct mailbox *mailbox, uint32_t id, char **body, size_t *length);
int mailbox_get_id_is_deleted(struct mailbox *mailbox, uint32_t id, bool *deleted);
int mailbox_get_id_is_quickmsg(struct mailbox *mailbox, uint32_t id, bool *quickmsg);
int mailbox_delete_id(struct mailbox *mailbox, uint32_t id);

#endif /* _INCLUDE_MAILBOX_H_ */
